winstd::crypt_key Class Reference
Cryptography API

HCRYPTKEY wrapper class. More...

`#include <WinStd/Crypt.h>`

Inheritance diagram for winstd::crypt_key:

## Public Member Functions

virtual | ~crypt_key ()
| Destroys the key. More...
bool | generate (HCRYPTPROV hProv, ALG_ID Algid, DWORD dwFlags) noexcept
| Generates the key. More...
bool | import (HCRYPTPROV hProv, __in_bcount(dwDataLen) LPCBYTE pbData, DWORD dwDataLen, HCRYPTKEY hPubKey, DWORD dwFlags) noexcept
| Imports the key. More...
bool | import_public (HCRYPTPROV hCryptProv, DWORD dwCertEncodingType, PCERT_PUBLIC_KEY_INFO pInfo) noexcept
| Imports the public key. More...
bool | derive (HCRYPTPROV hProv, ALG_ID Algid, HCRYPTHASH hBaseData, DWORD dwFlags) noexcept
| Generates cryptographic session keys derived from a base data value. More...
bool | create_exp1 (HCRYPTPROV hProv, DWORD dwKeySpec)
| Creates Exponent-of-one key. More...
Public Member Functions inherited from winstd::dplhandle< HCRYPTKEY, NULL >
| dplhandle () noexcept
| Initializes a new class instance with the object handle set to INVAL.
| dplhandle (handle_type h) noexcept
| Initializes a new class instance with an already available object handle. More...
| dplhandle (const dplhandle< handle_type, INVAL > &h) noexcept
| Copy constructor. More...
| dplhandle (dplhandle< handle_type, INVAL > &&h) noexcept
| Move constructor. More...
dplhandle< handle_type, INVAL > & | operator= (handle_type h) noexcept
| Attaches already available object handle. More...
dplhandle< handle_type, INVAL > & | operator= (const dplhandle< handle_type, INVAL > &h) noexcept
| Duplicates the object. More...
dplhandle< handle_type, INVAL > & | operator= (dplhandle< handle_type, INVAL > &&h) noexcept
| Moves the object. More...
handle_type | duplicate () const
| Duplicates and returns a new object handle. More...
bool | attach_duplicated (handle_type h)
| Duplicates an object handle and sets a new object handle. More...
Public Member Functions inherited from winstd::handle< HCRYPTKEY, INVAL >
| handle () noexcept
| Initializes a new class instance with the object handle set to INVAL.
| handle (handle_type h) noexcept
| Initializes a new class instance with an already available object handle. More...
| handle (handle< handle_type, INVAL > &&h) noexcept
| Move constructor. More...
handle< handle_type, INVAL > & | operator= (handle_type h) noexcept
| Attaches already available object handle. More...
handle< handle_type, INVAL > & | operator= (handle< handle_type, INVAL > &&h) noexcept
| Move assignment. More...
| operator handle_type () const
| Auto-typecasting operator. More...
handle_type *& | operator* () const
| Returns the object handle value when the object handle is a pointer to a value (class, struct, etc.). More...
handle_type * | operator& ()
| Returns the object handle reference. More...
handle_type | operator-> () const
| Provides object handle member access when the object handle is a pointer to a class or struct. More...
bool | operator! () const
| Tests if the object handle is INVAL. More...
bool | operator< (handle_type h) const
| Is handle less than? More...
bool | operator<= (handle_type h) const
| Is handle less than or equal to? More...
bool | operator>= (handle_type h) const
| Is handle greater than or equal to? More...
bool | operator> (handle_type h) const
| Is handle greater than? More...
bool | operator!= (handle_type h) const
| Is handle not equal to? More...
bool | operator== (handle_type h) const
| Is handle equal to? More...
void | attach (handle_type h) noexcept
| Sets a new object handle for the class. More...
handle_type | detach ()
| Dismisses the object handle from this class. More...
void | free ()
| Destroys the object.

## Protected Member Functions

void | free_internal () noexcept override
| Destroys the key. More...
handle_type | duplicate_internal (handle_type h) const noexcept override
| Duplicates the key. More...
virtual handle_type | duplicate_internal (handle_type h) const noexcept=0
| Abstract member function that must be implemented by child classes to do the actual object handle duplication. More...
virtual void | free_internal () noexcept=0
| Abstract member function that must be implemented by child classes to do the actual object destruction. More...

## Additional Inherited Members

Public Types inherited from winstd::handle< HCRYPTKEY, INVAL >
typedef HCRYPTKEY | handle_type
| Datatype of the object handle this template class handles.
Static Public Attributes inherited from winstd::handle< HCRYPTKEY, INVAL >
static const HCRYPTKEY | invalid
| Invalid handle value.
Protected Attributes inherited from winstd::handle< HCRYPTKEY, INVAL >
handle_type | m_h
| Object handle.

## Detailed Description

HCRYPTKEY wrapper class.

## Constructor & Destructor Documentation

## ~crypt_key()

virtual winstd::crypt_key::~crypt_key | ( |  | ) |

inlinevirtual

Destroys the key.

See also
  CryptDestroyKey function

## Member Function Documentation

## create_exp1()

bool winstd::crypt_key::create_exp1 | ( | HCRYPTPROV | hProv,
|  | DWORD | dwKeySpec
| ) |  |

inline

Creates Exponent-of-one key.

See also
  How to export and import plain text session keys by using CryptoAPI

Parameters

  [in] | hProv | Handle of cryptographics provider to use
  [in] | dwKeySpec | Key specification (`AT_KEYEXCHANGE` or `AT_SIGNATURE`)

## derive()

bool winstd::crypt_key::derive | ( | HCRYPTPROV | hProv,
|  | ALG_ID | Algid,
|  | HCRYPTHASH | hBaseData,
|  | DWORD | dwFlags
| ) |  |

inlinenoexcept

Generates cryptographic session keys derived from a base data value.

See also
  CryptDeriveKey function

## duplicate_internal()

handle_type winstd::crypt_key::duplicate_internal | ( | handle_type | h | ) | const

inlineoverrideprotectedvirtualnoexcept

Duplicates the key.

Parameters

  [in] | h | Object handle of existing key

Returns
  Duplicated key handle

See also
  CryptDuplicateKey function

Implements winstd::dplhandle< HCRYPTKEY, NULL >.

## free_internal()

void winstd::crypt_key::free_internal | ( |  | ) |

inlineoverrideprotectedvirtualnoexcept

Destroys the key.

See also
  CryptDestroyKey function

Implements winstd::handle< HCRYPTKEY, INVAL >.

## generate()

bool winstd::crypt_key::generate | ( | HCRYPTPROV | hProv,
|  | ALG_ID | Algid,
|  | DWORD | dwFlags
| ) |  |

inlinenoexcept

Generates the key.

See also
  CryptGenKey function

## import()

bool winstd::crypt_key::import | ( | HCRYPTPROV | hProv,
|  | __in_bcount(dwDataLen) LPCBYTE | pbData,
|  | DWORD | dwDataLen,
|  | HCRYPTKEY | hPubKey,
|  | DWORD | dwFlags
| ) |  |

inlinenoexcept

Imports the key.

See also
  CryptImportKey function

## import_public()

bool winstd::crypt_key::import_public | ( | HCRYPTPROV | hCryptProv,
|  | DWORD | dwCertEncodingType,
|  | PCERT_PUBLIC_KEY_INFO | pInfo
| ) |  |

inlinenoexcept

Imports the public key.

See also
  CryptImportPublicKeyInfo function

The documentation for this class was generated from the following file:

- include/WinStd/Crypt.h